package com.blazinggames.tmod
{
	public class PlayerInfo
	{
// ***** CONSTANTS *****
		
		// game types (the episodes)
		public static const GAMETYPE_ALEINSZOMBIES:int = 0; // TODO
		public static const GAMETYPE_MOONLANDINGS:int = 1; // TODO
		public static const GAMETYPE_MOONRUN:int = 2; // TODO
		public static const GAMETYPE_INVASION:int = 3; // TODO
		public static const GAMETYPE_SPACESHIELD:int = 4;
		public static const TOTAL_EPISODES:int = 5; 
		// TODO - Additional Episodes

		// game modes
		public static const STORY_GAME:int = 0;
		public static const UNLIMITED_GAME:int = 1;
		
		// difficulty constants
		public static const DIFFICULTY_EASY:int = 0;
		public static const DIFFICULTY_NORMAL:int = 1;
		public static const DIFFICULTY_HARD:int = 2;
		
// ***** VARIABLES *****
		
		private var _gameType:int;
		private var _gameMode:int;
		private var _score:int;
		private var _highScore:Array;
		private var _level:int;
		private var _lives:int;
		private var _difficulty:int;
		
// ***** CONSTRUCTOR *****
		
		public function PlayerInfo()
		{
			_highScore = new Array();
			for (var cntr = 0; cntr < TOTAL_EPISODES; ++cntr)
				_highScore[cntr] = 0;
		}

// ***** METHODS - Game Selection *****

		public function selectGame(	gameType:int, gameMode:int = UNLIMITED_GAME,
									lives:int = 3, level:int = 1,
									difficulty:int = DIFFICULTY_NORMAL)
		{
			_gameType = gameType;
			_gameMode = gameMode;
			_score = 0;
			_level = level;
			_lives = lives;
			_difficulty = difficulty;
		}

// ***** METHODS - Getters and Setters *****
		
		public function get gameType():int
		{
			return _gameType;
		}

		public function get gameMode():int
		{
			return _gameMode;
		}

		public function get score():int
		{
			return _score;
		}

		public function set score(value:int):void
		{
			_score = value;
		}

		public function get highScore():int
		{
			return _highScore[_gameType];
		}

		public function set highScore(value:int):void
		{
			_highScore[_gameType] = value;
		}

		public function get level():int
		{
			return _level;
		}

		public function set level(value:int):void
		{
			_level = value;
		}

		public function get lives():int
		{
			return _lives;
		}

		public function set lives(value:int):void
		{
			_lives = value;
		}

		public function get difficulty():int
		{
			return _difficulty;
		}


	}
}