package com.blazinggames.tmod.common
{
	public class DoubleLinkedList
	{
// ***** CONSTANTS *****
		
// ***** VARIABLES *****
		
		private var _rootNode:BasicDLLNode;

// ***** CONSTRUCTOR *****
		
		public function DoubleLinkedList()
		{
			_rootNode = new BasicDLLNode();
		}
		
// ***** METHODS - List Management *****
		
		public function addNode(node:IDoubleLinkedListNode):void
		{
			// make sure node not part of list by removing it
			removeNode(node);
			//
			var rootNext:IDoubleLinkedListNode = _rootNode.nextNode();
			if (rootNext != null) {
				rootNext.setPreviousNode(node);
			}
			// now add it to the beginning of this list
			node.setNextNode(rootNext);
			node.setPreviousNode(_rootNode);
			_rootNode.setNextNode(node);
		}
		
		public function removeNode(node:IDoubleLinkedListNode):void
		{
			// prevent removal of root node
			if (node == _rootNode)
				return;
			// remove from list by updating previous and next node
			var prev:IDoubleLinkedListNode = node.previousNode();
			var next:IDoubleLinkedListNode = node.nextNode();
			if (prev != null)
				prev.setNextNode(next);
			if (next != null)
				next.setPreviousNode(prev);
			node.setNextNode(null);
			node.setPreviousNode(null);
		}
		
		public function getFirstNode():IDoubleLinkedListNode
		{
			return _rootNode.nextNode();
		}
	}
}