package com.blazinggames.tmod.common.arcade
{
	import flash.display.MovieClip;
	
	/**
	 * A bullet icon that can be used as part of the LifeBar for a graphical
	 * representation as to how many bullets the player has or just as the
	 * icon for a x ### format display of ammunition.
	 * movies need to implement the following labels that
	 * reflect transitions and states:
	 * normal - HEART_NORMAL state is the full-life indicator
	 * losing - HEART_LOSING Animated loss of heart with transition to lost state
	 * lost - HEART_LOST reflects a missing life
	 * gaining - HEART_GAIN regaining health
	 * 
	 * It should be noted that the movie symbol does not have to be a bullet
	 * but can be any symbol that reflects the item being used.
	*/
	public class Bullet 
	extends MovieClip 
	implements ILifeIcon
	{
// ***** CONSTANTS *****
	
		private static const LABEL_NORMAL:String = "normal";
		private static const LABEL_LOSING:String = "losing";
		private static const LABEL_LOST:String = "lost";
		private static const LABEL_GAIN:String = "gaining";
	
// ***** VARIABLES *****
	
		private var alive:Boolean;
	
// ***** CONSTRUCTOR *****

		public function Bullet()
		{
			super();
			alive = true;
		}

// ***** METHODS - ILifeIcon implementation *****

		public function isAlive():Boolean
		{
			return alive;
		}
		
		public function endLife():void
		{
			if ( alive )
				gotoAndPlay(LABEL_LOSING);
			alive = false;
		}
		
		public function startLife():void
		{
			if ( ! alive )
				gotoAndPlay(LABEL_GAIN);
			alive = true;
		}
	}
}