package com.blazinggames.tmod.common.data
{
	public class ObjectPool
	{
		public static const POOL_RECYCLE:int = 0;
		public static const POOL_MAIN:int = 1;
		
		private var _pools:Array;
		private var _base:IPoolMember;
		
		public function ObjectPool(base:IPoolMember)
		{
			_pools = new Array();
			_base = base;
		}
		
		public function addToPool(itm:IPoolMember, pool:int = 1):void
		{
			if (_pools[pool] == null)
				_pools[pool] = new Array();
			itm.changePool(pool);
			_pools[pool].push(itm);
		}
		
		public function getPool(pool:int = 1, bClean:Boolean = false):Array
		{
			if (bClean)
				clean(pool);
			var array:Array = _pools[pool];
			if (array == null) {
				array = new Array();
				_pools[pool] = array;
			}
			return array;
		}
		
		public function clean(pool:int = 1):void
		{
			var indx:int = 0;
			var array:Array = _pools[pool];
			if (array == null) {
				array = new Array();
				_pools[pool] = array;
			}
			var len = array.length;
			for (var cntr:int = 0; cntr < len; ++cntr) {
				if (array[cntr].getCurrentPool() == pool) {
					array[indx] = array[cntr];
					++indx;
				} else {
					addToPool(array[cntr], array[cntr].getCurrentPool());
				}
			}
			if (indx < len)
				array.splice(indx);
		}
		
		public function recycle(itm:IPoolMember):void
		{
			itm.changePool( POOL_RECYCLE);
		}
		
		public function spawn(addPool:int = -1):IPoolMember
		{
			var array:Array = getPool(POOL_RECYCLE, true);
			var itm:IPoolMember;
			if (array.length > 0) {
				itm = array.pop();
				itm.copyState(_base);
			} else {
				itm = _base.createCopy();
			}
			
			if (addPool > 0)
				addToPool(itm, addPool);
			return itm;
		}
	}
}