package com.blazinggames.tmod.common.map
{
	/**
	 * The interface for a tile renderer. Quite simply the only requirements
	 * is that the tileID be able to be set and the dimensions be retreivable.
	 * It is assumed that tile renderers are top-left aligned. Extending beyond
	 * the bounds is allowed, but only the left and top extents are garanteed
	 * to be visilbe.
	 * 
	 * @author Billy D. Spelchan
	 */
	public interface ITileRenderer
	{
		/** The logical width of the tile. */
		function getTileWidth():Number;
		
		/** The logical height of the tile */
		function getTileHeight():Number;
		
		/** The current id (image to be shown) for the tile */
		function getTileID():Number;
		
		/** sets the image to be shown on the tile */
		function setTileID(id:int):void;
	}
}