package com.blazinggames.tmod.common.map
{
	import flash.geom.Point;

	public class MapController
	{
// ***** CONSTANTS *****
		
		public static const CLIP_MAP = 0;
		public static const WRAP_MAP = 1;

// ***** VARIABLES *****
		
		protected var _map:ITileMap;
		protected var _viewport:TileGridView;
		protected var _position:Point;
		protected var _viewMode:int;
		
// ***** CONSTRUCTOR *****
		
		public function MapController(map:ITileMap, view:TileGridView, mode:int=CLIP_MAP)
		{
			_map = map;
			_viewport = view;
			_position = new Point();
			_viewMode = mode;
			setPosition(0,0);
		}
		
// ***** view manipulation *****
		
		public function get position():Point
		{
			return _position;
		}

		public function setPosition(x:Number, y:Number)
		{
			var gw = _viewport.gridWidth;
			var gh = _viewport.gridHeight;
			var tx = x - (gw / 2);
			var ty = y - (gh / 2);
			
			if (_viewMode == CLIP_MAP) {
				if (tx < 0)
					tx = 0;
				if (ty < 0)
					ty = 0;
				if ((tx + gw) > _map.getWidth())
					tx = _map.getWidth() - gw;
				if ((ty + gh) > _map.getHeight())
					ty = _map.getHeight() - gh;
			}
			
			x = -(tx - Math.floor(tx)) * _viewport.tileWidth;
			y = -(ty - Math.floor(ty)) * _viewport.tileHeight;
			tx = Math.floor(tx);
			ty = Math.floor(ty);
			_position.x = tx;
			_position.y = ty;
			for (var cntrY:int = 0; cntrY < gh; ++cntrY) {
				for (var cntrX:int = 0; cntrX < gw; ++cntrX) {
					_viewport.setTile(cntrX,cntrY, _map.getTile(tx + cntrX, ty + cntrY));
				}
			}
		}
	}
}