package com.blazinggames.tmod.common.map
{
	import flash.display.DisplayObject;
	import flash.display.MovieClip;

	public class TileGridView extends MovieClip
	{
// ***** VARIABLES *****
		
		private var _grid:Array; // [Y][X] format
		private var _tileWidth:int, _tileHeight:int;
		private var _gridWidth:int, _gridHeight:int;
		
// ***** CONSTRUCTOR *****
		
		public function TileGridView(widthInTiles:int, heightInTiles:int, renderer:Class)
		{
			_gridWidth = widthInTiles;
			_gridHeight = heightInTiles;
			var tile:Object = new renderer();
			_tileWidth = tile.getTileWidth();
			_tileHeight = tile.getTileHeight();
			super();
			
			_grid = new Array(heightInTiles);
			for (var cntrY:int = 0; cntrY < heightInTiles; ++cntrY) {
				_grid[cntrY] = new Array(widthInTiles);
				for (var cntrX:int = 0; cntrX < widthInTiles; ++cntrX) {
					tile = new renderer();
					tile.x = cntrX * _tileWidth;
					tile.y = cntrY * _tileHeight;
					tile.setTileID(Math.floor(Math.random() * 11));
					addChild(DisplayObject(tile));
					_grid[cntrY][cntrX] = tile;
				}
			}
		}

// ***** METHODS - Getters and Setters *****
		
		public function get gridHeight():int
		{
			return _gridHeight;
		}

		public function get gridWidth():int
		{
			return _gridWidth;
		}

		public function get tileHeight()
		{
			return _tileHeight;
		}

		public function get tileWidth()
		{
			return _tileWidth;
		}

		public function setTile(tx:int, ty:int, value:int)
		{
			_grid[ty][tx].setTileID(value);
		}
	}
}